﻿using System;
using System.Diagnostics;
using Android.App;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Testing;

namespace Scratch.JMJMException
{
    [Activity(MainLauncher = true)]
    public class MainActivity : Activity
    {
        protected override void OnCreate(Bundle savedInstanceState)
        {
            base.OnCreate(savedInstanceState);
            Button b = new Button(this)
            {
                Text = "Click Me!",
            };
            b.Click += (o, e) =>
            {
                Testing.Run.TryCatchFinally(
                    new Java.Lang.Runnable(() =>
                    {
                        Console.WriteLine("# jon: Should be in a Java > Managed [MainActivity.OnCreate] > Java [Run.tryCatchFinally] > Managed [Run] frame. Throwing an exception...");
                        Console.WriteLine(new StackTrace(fNeedFileInfo: true).ToString());
                        throw new Exception("Should be in a Java > Managed [MainActivity.OnCreate] > Java [Run.tryCatchFinally] > Managed [Run] frame. Throwing an exception...");
                    }),
                    new MyCatchHandler(),
                    new Java.Lang.Runnable(() =>
                    {
                        Console.WriteLine($"# jon: from Java finally block");
                    })
                ); ;
            };
            SetContentView(b);
        }
    }

    class MyCatchHandler : Java.Lang.Object, Run.ICatchThrowableHandler
    {
        public void OnCatch(Java.Lang.Throwable t)
        {
            Console.WriteLine($"# jon: MyCatchHandler.OnCatch: t={t.ToString()}");
        }
    }
}
